﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Linq;
using System.Windows.Data;
using System.Windows.Media;
using System.Globalization;

namespace TestWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            this.Grid.QueryCoveredRange += Grid_QueryCoveredRange;
            
       


        }

        private void aab<TValue>(List<TValue> ah)
        {

            for (int i = 0; i < ah.Count; i++)
            {
                
                TableData k = ah[i] as TableData;

                Console.WriteLine(k.Date);

            }

        }

        /// <summary>
        /// Nalezeni indexu sloupce podle nazvu mapovani dat (nazev musi byt vzdy v tabulce, nesmi se vracet -1, jinak program spadne, konzistence zajistena podminkou pred volanim teto funkce)
        /// </summary>
        /// <param name="Grid"></param>
        /// <param name="MappingName"></param>
        /// <returns></returns>
        private int GetColumnIndexByMappingName(SfDataGrid Grid, string MappingName)
        {

            Columns GridColumns = new Columns();

            //--nejdrive se musi vyfiltrovat sloupce s prazdnym mapovanim (hlavicka druhe a vyssi urovne)
            foreach (GridColumn Column in Grid.Columns)
            {
                if (!string.IsNullOrEmpty(Column.MappingName)) GridColumns.Add(Column);
            }

            return GridColumns.IndexOf(Grid.Columns[MappingName]); 

        }

        /// <summary>
        /// Spojovani sloupcu a radku v tabulce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Grid_QueryCoveredRange(object sender, Syncfusion.UI.Xaml.Grid.GridQueryCoveredRangeEventArgs e)
        {

            SfDataGrid Grid = sender as SfDataGrid;

            if (e.RowColumnIndex.RowIndex % 2 == 0)
            {

                List<string> JoinDataName = new List<string>()
                {
                    "Date", "Bilance_ZTRCVstup_Sum", "Bilance_Destilat_Sum", "Bilance_Para_Sum", "Bilance_ZTRCVystup_Sum", "Bilance_CPVStandard_Sum", "Bilance_CPVStandard_Avg",
                    "Bilance_CPVNestandard_Sum", "Bilance_CPVNestandard_Avg", "Bilance_Kalolis_Sum", "Bilance_FiltracniKolac_A", "Bilance_FiltracniKolac_B", "Bilance_V5_Sum", 
                    "Bilance_HSCC47_Sum"
                };


                foreach (string NameIn in JoinDataName)
                {

                    if (e.GridColumn.MappingName == NameIn)
                    {

                        e.Range = new CoveredCellInfo(this.GetColumnIndexByMappingName(Grid, e.GridColumn.MappingName), GetColumnIndexByMappingName(Grid, e.GridColumn.MappingName), e.RowColumnIndex.RowIndex - 1, e.RowColumnIndex.RowIndex);
                        e.Handled = true;

                    }

                }

            }

        }

        class DataGridData : TableData
        {

            public string X { get { return null; } }

            public string Day { get; set; }
            public string Mistr { get; set; }
            public string Shift { get; set; }
            public double Bilance_ZTRCVstup { get { return GetRand(); } set { } }
            public double Bilance_ZTRCVstup_Sum { get { return GetRand(); } set { } }
            public double Bilance_Destilat { get { return GetRand(); } set { } }
            public double Bilance_Destilat_Sum { get { return GetRand(); } set { } }
            public double Bilance_NV { get { return GetRand(); } set { } }
            public double Bilance_TBCT4 { get { return GetRand(); } set { } }
            public double Bilance_PitnaVoda { get { return GetRand(); } set { } }
            public double Bilance_E14101 { get { return GetRand(); } set { } }
            public double Bilance_C402 { get { return GetRand(); } set { } }
            public double Bilance_PS01 { get { return GetRand(); } set { } }
            public double Bilance_Para_Sum { get { return GetRand(); } set { } }
            public double Bilance_DVS { get { return GetRand(); } set { } }
            public double Bilance_V5 { get { return GetRand(); } set { } }
            public double Bilance_HSCC47 { get { return GetRand(); } set { } }
            public double Bilance_ZTRCVystup_Sum { get { return GetRand(); } set { } }
            public double Bilance_CPVStandard { get { return GetRand(); } set { } }
            public double Bilance_CPVStandard_Sum { get { return GetRand(); } set { } }
            public double Bilance_CPVStandard_Avg { get { return GetRand(); } set { } }
            public double Bilance_CPVNestandard { get { return GetRand(); } set { } }
            public double Bilance_CPVNestandard_Sum { get { return GetRand(); } set { } }
            public double Bilance_CPVNestandard_Avg { get { return GetRand(); } set { } }
            public double Bilance_Kalolis { get { return GetRand(); } set { } }
            public double Bilance_Kalolis_Sum { get { return GetRand(); } set { } }
            public double Bilance_FiltracniKolac_A { get { return GetRand(); } set { } }
            public double Bilance_FiltracniKolac_B { get { return GetRand(); } set { } }
            public double Bilance_V5_Sum { get { return GetRand(); } set { } }
            public double Bilance_HSCC47_Sum { get { return GetRand(); } set { } }

            private static Random r = new Random();

            private double GetRand()
            {
              
                return r.Next(99999);
            }

        }

        List<DataGridData> GridData;

        private void LoadData(object sender, RoutedEventArgs e)
        {

            DateTime SelectedDate_ = (DateTime)DateTimeEdit.DateTime,
                     SelectedDate = new DateTime(SelectedDate_.Year, SelectedDate_.Month, 1);

            this.GridData = new List<DataGridData>();

            DateTime DateTo = SelectedDate.AddDays(5);

            int i = 0;
            bool even;

            DataGridData T;
            Random r = new Random();
            
            for (DateTime Date = SelectedDate.Date; Date.Date <= DateTo.AddDays(1).Date; Date = Date.AddDays(1))
            {

                i++;
                even = i % 2 == 0;

                T = new DataGridData()
                {
                    Date = Date,
                    Day = "den"
                };

                this.GridData.Add(T);

                T = new DataGridData()
                {
                    Date = Date,
                    Day = "noc"
                };

                this.GridData.Add(T);

            }

            Grid.ItemsSource = this.GridData;

            this.aab<DataGridData>(this.GridData);

        }



    }

    /// <summary>
    /// Zmena barvy pisma
    /// </summary>
    public class SumStyleConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, CultureInfo language)
        {

            return new SolidColorBrush((Color)ColorConverter.ConvertFromString("#FF0074FF"));

        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo language)
        {

            throw new NotImplementedException();

        }

    }

    /// <summary>
    /// Konvertovani vstupni hodnoty na cislo
    /// </summary>
    public class NumericConverter : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, CultureInfo language)
        {

            if (value is Double) return ((Double)value).ToString("N2", CultureInfo.CurrentUICulture);

            if (value is Decimal) return ((Decimal)value).ToString("N2", CultureInfo.CurrentUICulture);

            if (value is int) return value;

            return "";

        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo language)
        {

            throw new NotImplementedException();

        }

    }

}
